Package org.gradle.api.artifacts

## Interface ComponentSelectionRules

-     public interface ComponentSelectionRules

  Represents a container for component selection rules. Rules can be applied as part of the resolutionStrategy of a configuration and individual components can be explicitly accepted or rejected by rule. Components that are neither accepted or rejected will be subject to the default version matching strategies.

           configurations {
               conf {
                   resolutionStrategy {
                       componentSelection {
                           all { ComponentSelection selection ->
                               if (selection.candidate.module == 'someModule' && selection.candidate.version == '1.1') {
                                   selection.reject("bad version '1.1' for 'someModule'")
                               }
                           }
                           all { ComponentSelection selection ->
                               if (selection.candidate.module == 'someModule' && selection.getDescriptor(IvyModuleDescriptor)?.branch == 'testing') {
                                   if (selection.metadata == null || selection.metadata.status != 'milestone') {
                                       selection.reject("only use milestones for someModule:testing")
                                   }
                               }
                           }
                           withModule("org.sample:api") { ComponentSelection selection ->
                               if (selection.candidate.version == "1.1") {
                                   selection.reject("known bad version")
                               }
                           }
                       }
                   }
               }
           }

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `ComponentSelectionRules` | `all​(Closure<?> closure)` | Adds a component selection rule that will apply to all resolved components.
    `ComponentSelectionRules` | `all​(java.lang.Object ruleSource)` | Adds a rule-source backed component selection rule that will apply to all resolved components.
    `ComponentSelectionRules` | `all​(Action<? super ComponentSelection> selectionAction)` | Adds a simple component selection rule that will apply to all resolved components.
    `ComponentSelectionRules` | `withModule​(java.lang.Object id, Closure<?> closure)` | Adds a component selection rule that will apply to the specified module.
    `ComponentSelectionRules` | `withModule​(java.lang.Object id, java.lang.Object ruleSource)` | Adds a rule-source backed component selection rule that will apply to the specified module.
    `ComponentSelectionRules` | `withModule​(java.lang.Object id, Action<? super ComponentSelection> selectionAction)` | Adds a component selection rule that will apply to the specified module.

- - ### Method Detail

    - #### all

          ComponentSelectionRules all​(Action<? super ComponentSelection> selectionAction)

      Adds a simple component selection rule that will apply to all resolved components. Each rule will receive a `ComponentSelection` object as an argument.
      Parameters:
        `selectionAction` - the Action that implements a rule to be applied
      Returns:
        this

    - #### all

          ComponentSelectionRules all​(@DelegatesTo(ComponentSelection.class)
                                      Closure<?> closure)

      Adds a component selection rule that will apply to all resolved components. Each rule will receive a `ComponentSelection` object as an argument.
      Parameters:
        `closure` - the Closure that implements a rule to be applied
      Returns:
        this

    - #### all

          ComponentSelectionRules all​(java.lang.Object ruleSource)

      Adds a rule-source backed component selection rule that will apply to all resolved components. The ruleSource provides the rule as exactly one rule method annotated with `Mutate`. This rule method:
      - must return void.
      - must have `ComponentSelection` as its parameter.
      Parameters:
        `ruleSource` - an instance providing a rule implementation
      Returns:
        this

    - #### withModule

          ComponentSelectionRules withModule​(java.lang.Object id,
                                             Action<? super ComponentSelection> selectionAction)

      Adds a component selection rule that will apply to the specified module. Each rule will receive a `ComponentSelection` object as an argument.
      Parameters:
        `id` - the module to apply this rule to in "group:module" format or as a `ModuleIdentifier`
        `selectionAction` - the Action that implements a rule to be applied
      Returns:
        this

    - #### withModule

          ComponentSelectionRules withModule​(java.lang.Object id,
                                             @DelegatesTo(ComponentSelection.class)
                                             Closure<?> closure)

      Adds a component selection rule that will apply to the specified module. Each rule will receive a `ComponentSelection` object as an argument.
      Parameters:
        `id` - the module to apply this rule to in "group:module" format or as a `ModuleIdentifier`
        `closure` - the Closure that implements a rule to be applied
      Returns:
        this

    - #### withModule

          ComponentSelectionRules withModule​(java.lang.Object id,
                                             java.lang.Object ruleSource)

      Adds a rule-source backed component selection rule that will apply to the specified module. The ruleSource provides the rule as exactly one rule method annotated with `Mutate`. This rule method:
      - must return void.
      - must have `ComponentSelection` as its parameter.
      Parameters:
        `id` - the module to apply this rule to in "group:module" format or as a `ModuleIdentifier`
        `ruleSource` - an instance providing a rule implementation
      Returns:
        this